;CodeVisionAVR C Compiler V1.24.6 Professional
;(C) Copyright 1998-2005 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com
;e-mail:office@hpinfotech.com

;Chip type              : AT90S2313
;Clock frequency        : 4.000000 MHz
;Memory model           : Tiny
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External SRAM size     : 0
;Data Stack size        : 32 byte(s)
;Heap size              : 0 byte(s)
;Promote char to int    : No
;char is unsigned       : Yes
;8 bit enums            : Yes
;Word align FLASH struct: No
;Automatic register allocation : On

	.DEVICE AT90S2313
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU SPL=0x3D
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __se_bit=0x20
	.EQU __sm_mask=0x10

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+@2
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+@3
	LDS  R@1,@2+@3+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM


	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	RCALL __GETW1PF
	ICALL
	.ENDM


	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMRDW
	ICALL
	.ENDM


	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOV  R26,R@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOV  R26,R@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOV  R26,R@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	SUBI R26,-@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __GETB1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETW1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOV  R30,R0
	MOV  R31,R1
	.ENDM

	.MACRO __GETB2SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOV  R26,R0
	MOV  R27,R1
	.ENDM

	.MACRO __GETBRSX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTBSRX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "2313lcd.vec"
	.INCLUDE "2313lcd.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x80)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM
	ADIW R30,1
	MOV  R24,R0
	LPM
	ADIW R30,1
	MOV  R25,R0
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM
	ADIW R30,1
	MOV  R26,R0
	LPM
	ADIW R30,1
	MOV  R27,R0
	LPM
	ADIW R30,1
	MOV  R1,R0
	LPM
	ADIW R30,1
	MOV  R22,R30
	MOV  R23,R31
	MOV  R31,R0
	MOV  R30,R1
__GLOBAL_INI_LOOP:
	LPM
	ADIW R30,1
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOV  R30,R22
	MOV  R31,R23
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0xDF)
	OUT  SPL,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x80)
	LDI  R29,HIGH(0x80)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x80
;       1 /*********************************************
;       2 This program was produced by the
;       3 CodeWizardAVR V1.24.0 Standard
;       4 Automatic Program Generator
;       5  Copyright 1998-2003 HP InfoTech s.r.l.
;       6 http://www.hpinfotech.ro
;       7 e-mail:office@hpinfotech.ro
;       8 
;       9 Project : 
;      10 Version : 1.0.3.2
;      11 Date    : 2005.09.26    
;      12 Modified: 2007.08.30
;      13 Author  : Scienceprog.com                           
;      14 Company :                                 
;      15 Comments: 
;      16 
;      17 
;      18 Chip type           : AT90S2313
;      19 Clock frequency     : 4,000000 MHz
;      20 Memory model        : Tiny
;      21 External SRAM size  : 0
;      22 Data Stack size     : 32
;      23 *********************************************/
;      24 // Alphanumeric LCD Module functions  
;      25 //PORTB - LCD
;      26 //----------------------------
;      27 //Bit0 - RS(LCD Pin4)
;      28 //Bit1 - RD(LCD Pin4)
;      29 //Bit2 - EN(LCD Pin4)
;      30 //Bit3 - Neprijungtas
;      31 //Bit4 - DB4(LCD Pin4)
;      32 //Bit5 - DB5(LCD Pin4)
;      33 //Bit6 - DB6(LCD Pin4)
;      34 //Bit7 - DB7(LCD Pin4) 
;      35 #include <90s2313.h>    
;      36 #asm
;      37    .equ __lcd_port=0x18		
   .equ __lcd_port=0x18		
;      38 #endasm
;      39 #include <lcd.h>         	//LCD control library
;      40 #include <delay.h> 		//Delay control library
;      41 #define MinUp PIND.0		//Button PIND0  Increases minutes
;      42 #define MinDown PIND.1		//Button PIND1  Decreases minutes
;      43 #define SecUp PIND.4		//Button PIND4  Increases seconds
;      44 #define SecDown PIND.5		//Button PIND4  Decreases seconds 
;      45 #define Rellay_On PORTD.6=1     //Relay on by sending "1" to PIND6
;      46 #define Rellay_Off PORTD.6=0 	//Relay off by sending "0" to PIND6 
;      47 #define Start PIND.3		//Start Button
;      48 #define Stop PIND.2		//Stop/Clear Button
;      49 typedef unsigned char byte;
;      50 // Declare your global variables here  
;      51 unsigned char temp1, temp2, temp3,temp4, temp5, temp6, laikas, end_check;
;      52 char h1, h0, m1, m0, s1, s0, p2,p1,p0; 
_m0:
	.BYTE 0x1
_s1:
	.BYTE 0x1
_s0:
	.BYTE 0x1
_p2:
	.BYTE 0x1
_p1:
	.BYTE 0x1
_p0:
	.BYTE 0x1
;      53 char IsStart, IsStop, IsClear; 
_IsStart:
	.BYTE 0x1
_IsStop:
	.BYTE 0x1
_IsClear:
	.BYTE 0x1
;      54 unsigned int pp,pp1;
_pp:
	.BYTE 0x2
_pp1:
	.BYTE 0x2
;      55 //unsigned int total_secs; 
;      56 //float BarStep, Bar; 
;      57 //Define LCD simbol
;      58 flash byte kaire[8]={

	.CSEG
;      59 0b1000000,
;      60 0b0100000,
;      61 0b0010000,
;      62 0b0001000,
;      63 0b0000100,
;      64 0b0000010,
;      65 0b0000001,
;      66 0b0000000
;      67 };   
;      68 //Symbol addressses for rotation effect
;      69 flash byte sleshai[8]={
;      70 0b00000000,
;      71 0b01111100,
;      72 0b00101111,
;      73 0b10110000,
;      74 0b00000000,
;      75 0b01111100,
;      76 0b00101111,
;      77 0b10110000
;      78 };   
;      79 //Send simbol to LCD CGRAM
;      80 void define_char(byte flash *pc,byte char_code){
_define_char:
;      81 	byte i,a;
;      82 	a=(char_code<<3)|0x40;
	RCALL __SAVELOCR2
;	*pc -> Y+3
;	char_code -> Y+2
;	i -> R16
;	a -> R17
	LDD  R30,Y+2
	RCALL __LSLB3
	ORI  R30,0x40
	MOV  R17,R30
;      83 	for (i=0; i<8; i++) 
	LDI  R16,LOW(0)
_0x4:
	CPI  R16,8
	BRSH _0x5
;      84 		lcd_write_byte(a++,*pc++);
	ST   -Y,R17
	INC  R17
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	ADIW R30,1
	STD  Y+4,R30
	STD  Y+4+1,R31
	SBIW R30,1
	RCALL SUBOPT_0x0
	RCALL _lcd_write_byte
;      85 }
	SUBI R16,-1
	RJMP _0x4
_0x5:
	RCALL __LOADLOCR2
	ADIW R28,5
	RET
;      86 //Funscion displays time on LCD at (9,1) position
;      87 void disp_time(void){
_disp_time:
;      88         lcd_gotoxy(8,1);
	LDI  R30,LOW(8)
	RCALL SUBOPT_0x1
;      89         lcd_putchar(h1|0x30); 
	MOV  R30,R12
	RCALL SUBOPT_0x2
;      90         lcd_gotoxy(9,1);
	LDI  R30,LOW(9)
	RCALL SUBOPT_0x1
;      91         lcd_putchar(h0|0x30);
	MOV  R30,R13
	RCALL SUBOPT_0x2
;      92         lcd_gotoxy(10,1);
	LDI  R30,LOW(10)
	RCALL SUBOPT_0x1
;      93         lcd_putchar(0x3A);
	RCALL SUBOPT_0x3
;      94         lcd_gotoxy(11,1);
	LDI  R30,LOW(11)
	RCALL SUBOPT_0x1
;      95         lcd_putchar(m1|0x30);   
	MOV  R30,R14
	RCALL SUBOPT_0x2
;      96         lcd_gotoxy(12,1);
	LDI  R30,LOW(12)
	RCALL SUBOPT_0x1
;      97         lcd_putchar(m0|0x30); 
	LDS  R30,_m0
	RCALL SUBOPT_0x2
;      98         lcd_gotoxy(13,1);
	LDI  R30,LOW(13)
	RCALL SUBOPT_0x1
;      99         lcd_putchar(0x3A); 
	RCALL SUBOPT_0x3
;     100         lcd_gotoxy(14,1);
	LDI  R30,LOW(14)
	RCALL SUBOPT_0x1
;     101         lcd_putchar(s1|0x30);
	LDS  R30,_s1
	RCALL SUBOPT_0x2
;     102         lcd_gotoxy(15,1);
	LDI  R30,LOW(15)
	RCALL SUBOPT_0x1
;     103         lcd_putchar(s0|0x30);  
	LDS  R30,_s0
	RCALL SUBOPT_0x2
;     104 }     
	RET
;     105 //Setting time function  (max 60 min ir 60 sec)         
;     106 void peep(unsigned int koef)
;     107 {               
_peep:
;     108 DDRB.3=1;                     
	SBI  0x17,3
;     109 PORTB.3=0;   
	CBI  0x18,3
;     110 temp2=0;
	CLR  R5
;     111 while (temp2<=50)
_0x6:
	LDI  R30,LOW(50)
	CP   R30,R5
	BRLO _0x8
;     112 	{
;     113 	for(pp=1;pp<koef;pp++){}
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	STS  _pp,R30
	STS  _pp+1,R31
_0xA:
	LD   R30,Y
	LDD  R31,Y+1
	LDS  R26,_pp
	LDS  R27,_pp+1
	CP   R26,R30
	CPC  R27,R31
	BRSH _0xB
	LDS  R30,_pp
	LDS  R31,_pp+1
	ADIW R30,1
	STS  _pp,R30
	STS  _pp+1,R31
	RJMP _0xA
_0xB:
;     114 	PORTB.3=1;
	SBI  0x18,3
;     115 	delay_us(100);
	__DELAY_USB 133
;     116 	temp2++;
	INC  R5
;     117 	PORTB.3=0;  
	CBI  0x18,3
;     118 	delay_us(100);
	__DELAY_USB 133
;     119 	}                
	RJMP _0x6
_0x8:
;     120 		
;     121 
;     122 }            
	ADIW R28,2
	RET
;     123 void settime (void)
;     124 {     
_settime:
;     125        //	DDRD=0b01000000;
;     126        //	PORTD=0b00111111;  
;     127        
;     128        	lcd_gotoxy(0,0);
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x4
	RCALL _lcd_gotoxy
;     129        	lcd_putsf("   UV-80 v1.0   ");
	__POINTW1FN _0,0
	RCALL SUBOPT_0x5
;     130        	lcd_gotoxy(0,1);
	RCALL SUBOPT_0x6
;     131        	lcd_putsf("   2007.08.30   ");
	__POINTW1FN _0,17
	RCALL SUBOPT_0x5
;     132        	delay_ms(2000);
	RCALL SUBOPT_0x7
;     133        	lcd_clear();
;     134 while((IsStart&1)!=1) // Program loop
_0xC:
	LDS  R30,_IsStart
	RCALL SUBOPT_0x8
	BRNE PC+2
	RJMP _0xE
;     135 	{ 
;     136 
;     137        //	lcd_clear(); 
;     138        	 //	delay_ms(15);
;     139         lcd_gotoxy(0,0);
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x4
	RCALL _lcd_gotoxy
;     140        	lcd_putsf("Time delay     ");
	__POINTW1FN _0,34
	RCALL SUBOPT_0x5
;     141 	disp_time();
	RCALL _disp_time
;     142         PORTD.0=1; 
	SBI  0x12,0
;     143       	PORTD.1=1;  
	SBI  0x12,1
;     144       	PORTD.2=1;  
	SBI  0x12,2
;     145 	PORTD.3=1;
	SBI  0x12,3
;     146       	PORTD.4=1;
	SBI  0x12,4
;     147       	PORTD.5=1;
	SBI  0x12,5
;     148       	
;     149       	DDRD.0=0;
	CBI  0x11,0
;     150 	DDRD.1=0;  
	CBI  0x11,1
;     151 	DDRD.3=0; 
	CBI  0x11,3
;     152 	DDRD.2=0;
	CBI  0x11,2
;     153    	DDRD.4=0;
	CBI  0x11,4
;     154     	DDRD.5=0;
	CBI  0x11,5
;     155      	temp6++; 	// small delay
	INC  R9
;     156 	//check if MinUp button is pressed
;     157 	if ((MinUp&1)!=1)
	LDI  R30,0
	SBIC 0x10,0
	LDI  R30,1
	RCALL SUBOPT_0x8
	BREQ _0xF
;     158 		{  
;     159 	       //	delay_ms(25);
;     160 		// Increment minutes
;     161 	        if  (m0!=9) {m0++;}
	LDS  R26,_m0
	CPI  R26,LOW(0x9)
	BREQ _0x10
	LDS  R30,_m0
	SUBI R30,-LOW(1)
	STS  _m0,R30
;     162                         else   if  (m1!=5) {m1++; m0=0;}
	RJMP _0x11
_0x10:
	LDI  R30,LOW(5)
	CP   R30,R14
	BREQ _0x12
	INC  R14
	RCALL SUBOPT_0x9
;     163                         	else {m0=0; m1=0;} 
	RJMP _0x13
_0x12:
	RCALL SUBOPT_0x9
	CLR  R14
_0x13:
_0x11:
;     164                         	
;     165          	//Buzzer
;     166          	peep(8);
	RCALL SUBOPT_0xA
;     167 		// Wait for button release
;     168 		while ((MinUp&1)==0){} 
_0x14:
	LDI  R30,0
	SBIC 0x10,0
	LDI  R30,1
	ANDI R30,LOW(0x1)
	BREQ _0x14
;     169 		}   
;     170         //check if MinDown button is pressed 
;     171        	if ((MinDown&1)!=1)
_0xF:
	LDI  R30,0
	SBIC 0x10,1
	LDI  R30,1
	RCALL SUBOPT_0x8
	BREQ _0x17
;     172 		{       
;     173 		//Dekrement Minutes
;     174 		if  (m0!=0) {m0--;}
	RCALL SUBOPT_0xB
	BREQ _0x18
	RCALL SUBOPT_0xC
;     175                         else   if  (m1!=0) {m1--; m0=9;}
	RJMP _0x19
_0x18:
	TST  R14
	BREQ _0x1A
	RCALL SUBOPT_0xD
;     176                         	else {m0=9; m1=5;}
	RJMP _0x1B
_0x1A:
	LDI  R30,LOW(9)
	STS  _m0,R30
	LDI  R30,LOW(5)
	MOV  R14,R30
_0x1B:
_0x19:
;     177 		// Wait for button release
;     178 	         peep(6);
	RCALL SUBOPT_0xE
;     179 		while ((MinDown&1)==0){} 
_0x1C:
	LDI  R30,0
	SBIC 0x10,1
	LDI  R30,1
	ANDI R30,LOW(0x1)
	BREQ _0x1C
;     180 		} 
;     181         //  
;     182 	temp6--;   
_0x17:
	DEC  R9
;     183 	//check if SecUp button is pressed 
;     184        	if ((SecUp&1)!=1)
	LDI  R30,0
	SBIC 0x10,4
	LDI  R30,1
	RCALL SUBOPT_0x8
	BREQ _0x1F
;     185 		{           
;     186 		  if (s0!=9) {s0++;}
	LDS  R26,_s0
	CPI  R26,LOW(0x9)
	BREQ _0x20
	LDS  R30,_s0
	SUBI R30,-LOW(1)
	STS  _s0,R30
;     187         		else if (s1!=5) {s1++; s0=0;}
	RJMP _0x21
_0x20:
	LDS  R26,_s1
	CPI  R26,LOW(0x5)
	BREQ _0x22
	LDS  R30,_s1
	SUBI R30,-LOW(1)
	RCALL SUBOPT_0xF
;     188         			else {s0=0; s1=0;}
	RJMP _0x23
_0x22:
	LDI  R30,LOW(0)
	STS  _s0,R30
	STS  _s1,R30
_0x23:
_0x21:
;     189                 // Wait for button release
;     190 		peep(4);
	RCALL SUBOPT_0x10
;     191        		while ((SecUp&1)==0){} 
_0x24:
	LDI  R30,0
	SBIC 0x10,4
	LDI  R30,1
	ANDI R30,LOW(0x1)
	BREQ _0x24
;     192 		}       
;     193 	//check if SecDown button is pressed 
;     194        	if ((SecDown&1)!=1)
_0x1F:
	LDI  R30,0
	SBIC 0x10,5
	LDI  R30,1
	RCALL SUBOPT_0x8
	BREQ _0x27
;     195 		{  
;     196 		//Dekrement Seconds
;     197 		if (s0!=0) {s0--;}
	RCALL SUBOPT_0x11
	BREQ _0x28
	RCALL SUBOPT_0x12
;     198         		else if (s1!=0) {s1--; s0=9;}
	RJMP _0x29
_0x28:
	RCALL SUBOPT_0x13
	BREQ _0x2A
	RCALL SUBOPT_0x14
;     199         			else {s0=9; s1=5;}
	RJMP _0x2B
_0x2A:
	RCALL SUBOPT_0x15
	RCALL SUBOPT_0x16
_0x2B:
_0x29:
;     200                 // Wait for button release  
;     201        		peep(2);
	RCALL SUBOPT_0x17
;     202        		while ((SecDown&1)==0){} 
_0x2C:
	LDI  R30,0
	SBIC 0x10,5
	LDI  R30,1
	ANDI R30,LOW(0x1)
	BREQ _0x2C
;     203 		}   
;     204        	if ((Start)!=1)
_0x27:
	SBIC 0x10,3
	RJMP _0x2F
;     205 		{
;     206 		IsStart=1;  
	LDI  R30,LOW(1)
	STS  _IsStart,R30
;     207 		peep(8);
	RCALL SUBOPT_0xA
;     208 		peep(8);
	RCALL SUBOPT_0xA
;     209 		peep(8);
	RCALL SUBOPT_0xA
;     210 		peep(8);
	RCALL SUBOPT_0xA
;     211 		delay_ms(10);
	RCALL SUBOPT_0x18
	RCALL _delay_ms
;     212 		peep(6); 
	RCALL SUBOPT_0xE
;     213 		peep(6);
	RCALL SUBOPT_0xE
;     214 		peep(6);
	RCALL SUBOPT_0xE
;     215 		delay_ms(8);
	LDI  R30,LOW(8)
	LDI  R31,HIGH(8)
	RCALL SUBOPT_0x19
;     216 		peep(4);    
	RCALL SUBOPT_0x10
;     217 		peep(4);
	RCALL SUBOPT_0x10
;     218 		delay_ms(5);
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	RCALL SUBOPT_0x19
;     219 		peep(2);
	RCALL SUBOPT_0x17
;     220 		while ((Start)==0){}
_0x30:
	SBIS 0x10,3
	RJMP _0x30
;     221 		}   
;     222 	}
_0x2F:
	RJMP _0xC
_0xE:
;     223 
;     224 }   
	RET
;     225 
;     226 void main(void)   //Main program
;     227 {  
_main:
;     228 for (pp1=1;pp1<50;pp1++)
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	STS  _pp1,R30
	STS  _pp1+1,R31
_0x34:
	LDS  R26,_pp1
	LDS  R27,_pp1+1
	CPI  R26,LOW(0x32)
	LDI  R30,HIGH(0x32)
	CPC  R27,R30
	BRSH _0x35
;     229 {
;     230 peep(5);
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	RCALL SUBOPT_0x1A
;     231 
;     232 }
	LDS  R30,_pp1
	LDS  R31,_pp1+1
	ADIW R30,1
	STS  _pp1,R30
	STS  _pp1+1,R31
	RJMP _0x34
_0x35:
;     233 PORTB=0x00;
	LDI  R30,LOW(0)
	OUT  0x18,R30
;     234 DDRB=0xFF;
	LDI  R30,LOW(255)
	OUT  0x17,R30
;     235 
;     236 PORTD=0x00;
	LDI  R30,LOW(0)
	OUT  0x12,R30
;     237 DDRD=0x7F;
	LDI  R30,LOW(127)
	OUT  0x11,R30
;     238 
;     239 // Timer/Counter 0 initialization
;     240 TCCR0=0x00;
	LDI  R30,LOW(0)
	OUT  0x33,R30
;     241 TCNT0=0x00;
	OUT  0x32,R30
;     242 
;     243 // Timer/Counter 1 initialization
;     244 
;     245 TCCR1A=0x00;
	OUT  0x2F,R30
;     246 TCCR1B=0x00;
	OUT  0x2E,R30
;     247 TCNT1H=0x00;
	OUT  0x2D,R30
;     248 TCNT1L=0x00;
	OUT  0x2C,R30
;     249 OCR1H=0x00;
	OUT  0x2B,R30
;     250 OCR1L=0x00;
	OUT  0x2A,R30
;     251 
;     252 
;     253 // Timer(s)/Counter(s) Interrupt(s) initialization
;     254 TIMSK=0x00;
	OUT  0x39,R30
;     255   
;     256 //Initial values   
;     257 temp1=0;
	CLR  R4
;     258 temp3=0; 
	CLR  R6
;     259 temp4=0;
	CLR  R7
;     260 temp5=0; 
	CLR  R8
;     261 temp6=0;
	CLR  R9
;     262 laikas=0; 
	CLR  R10
;     263 IsStart=0;
	STS  _IsStart,R30
;     264 IsStop=0;
	STS  _IsStop,R30
;     265 IsClear=0;  
	STS  _IsClear,R30
;     266                    
;     267 //Initial time values
;     268 h1=0;//Leave always 0
	CLR  R12
;     269 h0=0;//Leave always 0 
	CLR  R13
;     270 m1=0;
	CLR  R14
;     271 m0=3;
	LDI  R30,LOW(3)
	STS  _m0,R30
;     272 s1=0;
	LDI  R30,LOW(0)
	RCALL SUBOPT_0xF
;     273 s0=0;    
;     274 
;     275 // LCD module initialization   
;     276 lcd_init(16);  
	LDI  R30,LOW(16)
	ST   -Y,R30
	RCALL _lcd_init
;     277 Rellay_Off;
	CBI  0x12,6
;     278 //define custom char on LCD CGRAM
;     279 define_char(kaire,0);
	LDI  R30,LOW(_kaire*2)
	LDI  R31,HIGH(_kaire*2)
	ST   -Y,R31
	ST   -Y,R30
	RCALL SUBOPT_0x4
	RCALL _define_char
;     280 delay_ms(2000); //1 second
	RCALL SUBOPT_0x7
;     281 lcd_clear();   
;     282 //lcd_putchar(0); 
;     283 //Time input
;     284 settime();    
	RCALL _settime
;     285 lcd_gotoxy(0,0);  
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x4
	RCALL _lcd_gotoxy
;     286 lcd_putsf("Relay On");
	__POINTW1FN _0,50
	RCALL SUBOPT_0x5
;     287 DDRD.6=1;  
	SBI  0x11,6
;     288 Rellay_On;//Start relay and start coundown   
	SBI  0x12,6
;     289 delay_ms(7000);
	LDI  R30,LOW(7000)
	LDI  R31,HIGH(7000)
	RCALL SUBOPT_0x19
;     290 DDRD.2=0;
	CBI  0x11,2
;     291 DDRD.3=0;
	CBI  0x11,3
;     292 PORTD.2=1;
	SBI  0x12,2
;     293 PORTD.3=1;    
	SBI  0x12,3
;     294 
;     295 while (!end_check)//
_0x36:
	TST  R11
	BREQ PC+2
	RJMP _0x38
;     296 	{ 
;     297 	    	      
;     298 //Char animation on LCD ********************
;     299 		lcd_gotoxy(0,1);
	RCALL SUBOPT_0x6
;     300 		delay_ms(1000);
	RCALL SUBOPT_0x1B
;     301 		lcd_putchar(sleshai[temp3]);  
	LDI  R26,LOW(_sleshai*2)
	LDI  R27,HIGH(_sleshai*2)
	MOV  R30,R6
	LDI  R31,0
	ADD  R30,R26
	ADC  R31,R27
	RCALL SUBOPT_0x0
	RCALL _lcd_putchar
;     302 		temp3++;
	INC  R6
;     303 		if (temp3==8) temp3=0;    
	LDI  R30,LOW(8)
	CP   R30,R6
	BRNE _0x39
	CLR  R6
;     304     
;     305 	       	 	 if (temp1==0)
_0x39:
	TST  R4
	BRNE _0x3A
;     306 	       	 	 	{
;     307 	       	 	 	lcd_gotoxy(0,0);
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x4
	RCALL _lcd_gotoxy
;     308 	       	 	 	lcd_putsf("!!!!!Warning!!!!!");
	__POINTW1FN _0,59
	RCALL SUBOPT_0x5
;     309 	       	 	 	temp1++;
	INC  R4
;     310 	       	 	 	}                   
;     311 	       	 	 else if (temp1==1)
	RJMP _0x3B
_0x3A:
	LDI  R30,LOW(1)
	CP   R30,R4
	BRNE _0x3C
;     312 	       	 	 	{
;     313 	       	 	 	lcd_gotoxy(0,0);
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x4
	RCALL _lcd_gotoxy
;     314 	       	 	 	lcd_putsf("!!!    UV     !!!");
	__POINTW1FN _0,77
	RCALL SUBOPT_0x5
;     315 	       	 	 	temp1++;
	INC  R4
;     316 	       	 	 	}                      
;     317 	       	 	 else if (temp1==2)
	RJMP _0x3D
_0x3C:
	LDI  R30,LOW(2)
	CP   R30,R4
	BRNE _0x3E
;     318 	       	 	 	{
;     319 	       	 	 	lcd_gotoxy(0,0);
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x4
	RCALL _lcd_gotoxy
;     320 	       	 	 	lcd_putsf("!!!!!Exposure!!!!");
	__POINTW1FN _0,95
	RCALL SUBOPT_0x5
;     321 	       	 	 	temp1++;
	INC  R4
;     322 	       	 	 	}  
;     323 	       	 	 else if (temp1==3)
	RJMP _0x3F
_0x3E:
	LDI  R30,LOW(3)
	CP   R30,R4
	BRNE _0x40
;     324 	       	 	 	{
;     325 	       	 	 	lcd_gotoxy(0,0);
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x4
	RCALL _lcd_gotoxy
;     326 	       	 	 	lcd_putsf("!!Do not look!!");
	__POINTW1FN _0,113
	RCALL SUBOPT_0x5
;     327 	       	 	 	temp1=0;
	CLR  R4
;     328 	       	 	 	}            
;     329 //Time countdown*******************
;     330        if (s0!=0) {s0--; end_check=0;}
_0x40:
_0x3F:
_0x3D:
_0x3B:
	RCALL SUBOPT_0x11
	BREQ _0x41
	RCALL SUBOPT_0x12
	CLR  R11
;     331         else if (s1!=0) {s1--; s0=9; end_check=0;}
	RJMP _0x42
_0x41:
	RCALL SUBOPT_0x13
	BREQ _0x43
	RCALL SUBOPT_0x14
	CLR  R11
;     332                 else if  (m0!=0) {m0--; s1=5;s0=9;end_check=0;}
	RJMP _0x44
_0x43:
	RCALL SUBOPT_0xB
	BREQ _0x45
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0x16
	RCALL SUBOPT_0x15
	CLR  R11
;     333                         else   if  (m1!=0) {m1--; m0=9;s1=5;s0=9;end_check=0;}
	RJMP _0x46
_0x45:
	TST  R14
	BREQ _0x47
	RCALL SUBOPT_0xD
	RCALL SUBOPT_0x16
	RCALL SUBOPT_0x15
	CLR  R11
;     334                                 else   end_check=1;
	RJMP _0x48
_0x47:
	LDI  R30,LOW(1)
	MOV  R11,R30
;     335                 
;     336                 
;     337 //Exposure over***************
;     338                 if  (!end_check) disp_time();
_0x48:
_0x46:
_0x44:
_0x42:
	TST  R11
	BRNE _0x49
	RCALL _disp_time
;     339                         else {lcd_gotoxy(0,0); lcd_putsf("****Finished!***"); Rellay_Off; break;}//Stop relay
	RJMP _0x4A
_0x49:
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x4
	RCALL _lcd_gotoxy
	__POINTW1FN _0,129
	RCALL SUBOPT_0x5
	CBI  0x12,6
	RJMP _0x38
_0x4A:
;     340 	}
	RJMP _0x36
_0x38:
;     341 
;     342 while (1)
_0x4B:
;     343       {
;     344       // Place your code here
;     345       lcd_clear(); 
	RCALL _lcd_clear
;     346       delay_ms(1000); 
	RCALL SUBOPT_0x1B
;     347       peep(15); 
	RCALL SUBOPT_0x1C
;     348       peep(15);
	RCALL SUBOPT_0x1C
;     349       peep(15);
	RCALL SUBOPT_0x1C
;     350       peep(15);
	RCALL SUBOPT_0x1C
;     351       peep(15);   
	RCALL SUBOPT_0x1C
;     352       peep(15); 
	RCALL SUBOPT_0x1C
;     353       peep(15);
	RCALL SUBOPT_0x1C
;     354       peep(15);
	RCALL SUBOPT_0x1C
;     355       lcd_gotoxy(0,0); 
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x4
	RCALL _lcd_gotoxy
;     356       lcd_putsf("****Finished!***");
	__POINTW1FN _0,129
	RCALL SUBOPT_0x5
;     357       delay_ms(1000);
	RCALL SUBOPT_0x1B
;     358       peep(10); 
	RCALL SUBOPT_0x18
	RCALL SUBOPT_0x1D
;     359       peep(10); 
	RCALL SUBOPT_0x1D
;     360       peep(10); 
	RCALL SUBOPT_0x1D
;     361       peep(10); 
	RCALL SUBOPT_0x1D
;     362       peep(10); 
	RCALL SUBOPT_0x1D
;     363       peep(10); 
	RCALL SUBOPT_0x1D
;     364       peep(10);
	RCALL _peep
;     365       
;     366       };
	RJMP _0x4B
;     367 }
_0x4E:
	RJMP _0x4E
;     368 

    .equ __lcd_direction=__lcd_port-1
    .equ __lcd_pin=__lcd_port-2
    .equ __lcd_rs=0
    .equ __lcd_rd=1
    .equ __lcd_enable=2
    .equ __lcd_busy_flag=7

	.DSEG
__base_y_G2:
	.BYTE 0x4
__lcd_x:
	.BYTE 0x1
__lcd_y:
	.BYTE 0x1
__lcd_maxx:
	.BYTE 0x1

	.CSEG
__lcd_delay_G2:
    ldi   r31,15
__lcd_delay0:
    dec   r31
    brne  __lcd_delay0
	RET
__lcd_ready:
    in    r26,__lcd_direction
    andi  r26,0xf                 ;set as input
    out   __lcd_direction,r26
    sbi   __lcd_port,__lcd_rd     ;RD=1
    cbi   __lcd_port,__lcd_rs     ;RS=0
__lcd_busy:
	RCALL __lcd_delay_G2
    sbi   __lcd_port,__lcd_enable ;EN=1
	RCALL __lcd_delay_G2
    in    r26,__lcd_pin
    cbi   __lcd_port,__lcd_enable ;EN=0
	RCALL __lcd_delay_G2
    sbi   __lcd_port,__lcd_enable ;EN=1
	RCALL __lcd_delay_G2
    cbi   __lcd_port,__lcd_enable ;EN=0
    sbrc  r26,__lcd_busy_flag
    rjmp  __lcd_busy
	RET
__lcd_write_nibble_G2:
    andi  r26,0xf0
    or    r26,r27
    out   __lcd_port,r26          ;write
    sbi   __lcd_port,__lcd_enable ;EN=1
	RCALL __lcd_delay_G2
    cbi   __lcd_port,__lcd_enable ;EN=0
	RCALL __lcd_delay_G2
	RET
__lcd_write_data:
    cbi  __lcd_port,__lcd_rd 	  ;RD=0
    in    r26,__lcd_direction
    ori   r26,0xf0 | (1<<__lcd_rs) | (1<<__lcd_rd) | (1<<__lcd_enable) ;set as output    
    out   __lcd_direction,r26
    in    r27,__lcd_port
    andi  r27,0xf
    ld    r26,y
	RCALL __lcd_write_nibble_G2
    ld    r26,y
    swap  r26
	RCALL __lcd_write_nibble_G2
    sbi   __lcd_port,__lcd_rd     ;RD=1
	ADIW R28,1
	RET
_lcd_write_byte:
	RCALL __lcd_ready
	LDD  R30,Y+1
	RCALL SUBOPT_0x1E
	RCALL __lcd_ready
    sbi   __lcd_port,__lcd_rs     ;RS=1
	LD   R30,Y
	RCALL SUBOPT_0x1E
	ADIW R28,2
	RET
__lcd_read_nibble_G2:
    sbi   __lcd_port,__lcd_enable ;EN=1
	RCALL __lcd_delay_G2
    in    r30,__lcd_pin           ;read
    cbi   __lcd_port,__lcd_enable ;EN=0
	RCALL __lcd_delay_G2
    andi  r30,0xf0
	RET
_lcd_read_byte0_G2:
	RCALL __lcd_delay_G2
	RCALL __lcd_read_nibble_G2
    mov   r26,r30
	RCALL __lcd_read_nibble_G2
    cbi   __lcd_port,__lcd_rd     ;RD=0
    swap  r30
    or    r30,r26
	RET
_lcd_gotoxy:
	RCALL __lcd_ready
	LD   R30,Y
	SUBI R30,-LOW(__base_y_G2)
	LD   R30,Z
	LDD  R26,Y+1
	ADD  R30,R26
	RCALL SUBOPT_0x1E
	LDD  R30,Y+1
	STS  __lcd_x,R30
	LD   R30,Y
	STS  __lcd_y,R30
	ADIW R28,2
	RET
_lcd_clear:
	RCALL __lcd_ready
	LDI  R30,LOW(2)
	RCALL SUBOPT_0x1E
	RCALL __lcd_ready
	LDI  R30,LOW(12)
	RCALL SUBOPT_0x1E
	RCALL __lcd_ready
	LDI  R30,LOW(1)
	RCALL SUBOPT_0x1E
	LDI  R30,LOW(0)
	STS  __lcd_y,R30
	STS  __lcd_x,R30
	RET
_lcd_putchar:
    push r30
    push r31
    ld   r26,y
    set
    cpi  r26,10
    breq __lcd_putchar1
    clt
	LDS  R30,__lcd_x
	SUBI R30,-LOW(1)
	STS  __lcd_x,R30
	LDS  R30,__lcd_maxx
	LDS  R26,__lcd_x
	CP   R30,R26
	BRSH _0x50
	__lcd_putchar1:
	LDS  R30,__lcd_y
	SUBI R30,-LOW(1)
	STS  __lcd_y,R30
	RCALL SUBOPT_0x4
	LDS  R30,__lcd_y
	ST   -Y,R30
	RCALL _lcd_gotoxy
	brts __lcd_putchar0
_0x50:
    rcall __lcd_ready
    sbi  __lcd_port,__lcd_rs ;RS=1
    ld   r26,y
    st   -y,r26
    rcall __lcd_write_data
__lcd_putchar0:
    pop  r31
    pop  r30
	ADIW R28,1
	RET
_lcd_putsf:
    ld   r30,y
    ldd  r31,y+1
__lcd_putsf0:
	lpm
    tst  r0
    breq __lcd_putsf1
    adiw r30,1
    st   -y,r0
    rcall _lcd_putchar
    rjmp __lcd_putsf0
__lcd_putsf1:
	ADIW R28,2
	RET
__long_delay_G2:
    clr   r26
    clr   r27
__long_delay0:
    sbiw  r26,1         ;2 cycles
    brne  __long_delay0 ;2 cycles
	RET
__lcd_init_write_G2:
    cbi  __lcd_port,__lcd_rd 	  ;RD=0
    in    r26,__lcd_direction
    ori   r26,0xf7                ;set as output
    out   __lcd_direction,r26
    in    r27,__lcd_port
    andi  r27,0xf
    ld    r26,y
	RCALL __lcd_write_nibble_G2
    sbi   __lcd_port,__lcd_rd     ;RD=1
	ADIW R28,1
	RET
_lcd_init:
    cbi   __lcd_port,__lcd_enable ;EN=0
    cbi   __lcd_port,__lcd_rs     ;RS=0
	LD   R30,Y
	STS  __lcd_maxx,R30
	SUBI R30,-LOW(128)
	__PUTB1MN __base_y_G2,2
	LD   R30,Y
	SUBI R30,-LOW(192)
	__PUTB1MN __base_y_G2,3
	RCALL SUBOPT_0x1F
	RCALL SUBOPT_0x1F
	RCALL SUBOPT_0x1F
	RCALL __long_delay_G2
	LDI  R30,LOW(32)
	ST   -Y,R30
	RCALL __lcd_init_write_G2
	RCALL __long_delay_G2
	LDI  R30,LOW(40)
	RCALL SUBOPT_0x1E
	RCALL __long_delay_G2
	LDI  R30,LOW(4)
	RCALL SUBOPT_0x1E
	RCALL __long_delay_G2
	LDI  R30,LOW(133)
	RCALL SUBOPT_0x1E
	RCALL __long_delay_G2
    in    r26,__lcd_direction
    andi  r26,0xf                 ;set as input
    out   __lcd_direction,r26
    sbi   __lcd_port,__lcd_rd     ;RD=1
	RCALL _lcd_read_byte0_G2
	CPI  R30,LOW(0x5)
	BREQ _0x51
	LDI  R30,LOW(0)
	RJMP _0x52
_0x51:
	RCALL __lcd_ready
	LDI  R30,LOW(6)
	RCALL SUBOPT_0x1E
	RCALL _lcd_clear
	LDI  R30,LOW(1)
_0x52:
	ADIW R28,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x0:
	LPM
	MOV  R30,R0
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES
SUBOPT_0x1:
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RJMP _lcd_gotoxy

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES
SUBOPT_0x2:
	ORI  R30,LOW(0x30)
	ST   -Y,R30
	RJMP _lcd_putchar

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x3:
	LDI  R30,LOW(58)
	ST   -Y,R30
	RJMP _lcd_putchar

;OPTIMIZER ADDED SUBROUTINE, CALLED 20 TIMES
SUBOPT_0x4:
	LDI  R30,LOW(0)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES
SUBOPT_0x5:
	ST   -Y,R31
	ST   -Y,R30
	RJMP _lcd_putsf

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x6:
	LDI  R30,LOW(0)
	RJMP SUBOPT_0x1

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x7:
	LDI  R30,LOW(2000)
	LDI  R31,HIGH(2000)
	ST   -Y,R31
	ST   -Y,R30
	RCALL _delay_ms
	RJMP _lcd_clear

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0x8:
	ANDI R30,LOW(0x1)
	CPI  R30,LOW(0x1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x9:
	LDI  R30,LOW(0)
	STS  _m0,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0xA:
	LDI  R30,LOW(8)
	LDI  R31,HIGH(8)
	ST   -Y,R31
	ST   -Y,R30
	RJMP _peep

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xB:
	LDS  R30,_m0
	CPI  R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xC:
	LDS  R30,_m0
	SUBI R30,LOW(1)
	STS  _m0,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xD:
	DEC  R14
	LDI  R30,LOW(9)
	STS  _m0,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0xE:
	LDI  R30,LOW(6)
	LDI  R31,HIGH(6)
	ST   -Y,R31
	ST   -Y,R30
	RJMP _peep

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xF:
	STS  _s1,R30
	LDI  R30,LOW(0)
	STS  _s0,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x10:
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	ST   -Y,R31
	ST   -Y,R30
	RJMP _peep

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x11:
	LDS  R30,_s0
	CPI  R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x12:
	LDS  R30,_s0
	SUBI R30,LOW(1)
	STS  _s0,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x13:
	LDS  R30,_s1
	CPI  R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x14:
	LDS  R30,_s1
	SUBI R30,LOW(1)
	STS  _s1,R30
	LDI  R30,LOW(9)
	STS  _s0,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x15:
	LDI  R30,LOW(9)
	STS  _s0,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x16:
	LDI  R30,LOW(5)
	STS  _s1,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x17:
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	ST   -Y,R31
	ST   -Y,R30
	RJMP _peep

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES
SUBOPT_0x18:
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES
SUBOPT_0x19:
	ST   -Y,R31
	ST   -Y,R30
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES
SUBOPT_0x1A:
	ST   -Y,R31
	ST   -Y,R30
	RJMP _peep

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x1B:
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	RJMP SUBOPT_0x19

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES
SUBOPT_0x1C:
	LDI  R30,LOW(15)
	LDI  R31,HIGH(15)
	RJMP SUBOPT_0x1A

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES
SUBOPT_0x1D:
	RCALL _peep
	RJMP SUBOPT_0x18

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES
SUBOPT_0x1E:
	ST   -Y,R30
	RJMP __lcd_write_data

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x1F:
	RCALL __long_delay_G2
	LDI  R30,LOW(48)
	ST   -Y,R30
	RJMP __lcd_init_write_G2

_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x3E8
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__LSLB3:
	LSL  R30
	LSL  R30
	LSL  R30
	RET

__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

;END OF CODE MARKER
__END_OF_CODE:
